unit Main1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, XPMan;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    ButtonOK: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ButtonCancle: TButton;
    XPManifest1: TXPManifest;
    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancleClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const MAX_ROW: integer = 30;
const MAX_COL: integer = 30;

var
  Form1: TForm1;

{Actual Row, Column size}
  ROW_Cnt: integer;
  COL_Cnt: integer;

implementation

{$R *.dfm}

uses Slave1;

{OK button click}
procedure TForm1.ButtonOKClick(Sender: TObject);
var
  i, count: integer;
  row, col: integer;
  s: string;
begin
  if (Edit1.Text = '') or (Edit2.Text = '') then
    MessageDlg('Enter the dimensions of the matrix!',mtInformation,[mbOK],0)
  else
  begin
    s := Edit1.Text + Edit2.Text;
    count := 1;
    for i:= 1 to Length(s) do
      if (s[i] in ['0'..'9']) then Inc(count);
    if count <> i then
      MessageDlg('Check dimensions of the matrix!' + #13#10
                  + 'It must be a positive integer number!',mtInformation,[mbOK],0)
    else
    begin
      row := strtoint(Edit1.Text);
      col := strtoint(Edit2.Text);
      if ((row>0) and (col>0)) and ((row<=MAX_ROW) and (col<=MAX_COL)) then
      begin
        ROW_Cnt := row;
        COL_Cnt := col;
        Edit1.Clear;
        Edit2.Clear;
        Form2.DrawTable(ROW_Cnt, COL_Cnt);
        Form2.CleanTable;
        Form2.Caption := 'Matrix: '+inttostr(ROW_Cnt)+'x'+inttostr(COL_Cnt);
        Form2.UnDo1.Enabled := False;
        Form1.Visible := False;
        Form2.Visible := True;
      end
      else
        MessageDlg('The dimensions of the matrix are outside of allowed range!',mtInformation,[mbOK],0);
    end;
  end;
end;

{Cancle button click}
procedure TForm1.ButtonCancleClick(Sender: TObject);
begin
  Edit1.Clear;
  Edit2.Clear;
end;

{Hide the Maximize button of a Form1}
procedure TForm1.FormCreate(Sender: TObject);
var
  i: DWORD;
begin
  i := GetWindowLong(Self.Handle, GWL_STYLE);
  i := i and not (WS_MAXIMIZEBOX);
  i := SetWindowLong(Self.Handle, GWL_STYLE, i);
end;

end.
